	.area text(rom,rel)
	.dbfile ..\..\..\..\..\PROGRA~1\iccv7prop\Projects\LTC1298\Ltc1298.c
	.area lit(rom,rel)
	.align	4
_LTC1298_CH0:
	.long 13
	.dbfile C:\PROGRA~1\iccv7prop\Projects\LTC1298\Ltc1298.c
	.dbsym s LTC1298_CH0 _LTC1298_CH0 I
	.align	4
_LTC1298_CH1:
	.long 15
	.dbsym s LTC1298_CH1 _LTC1298_CH1 I
	.area text(rom,rel)
	.dbfile C:\PROGRA~1\iccv7prop\Projects\LTC1298\Ltc1298.c
	.dbfunc e setupLTC1298 _setupLTC1298 fV
;           data -> R2
;            clk -> R1
;             cs -> R0
_setupLTC1298::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 17
; /*
; LTC1298 Function File
; 
; */
; #include <propeller.h>
; #include "ltc1298header.h"
; 
; 
; static const int LTC1298_CH0 = 0b1101;						   // The address for CH0 return
; static const int LTC1298_CH1 = 0b1111;						   // The address for CH1 return
; 
; 
; static int LTC1298_cs, LTC1298_clk, LTC1298_data;						   // Pin address for function use
; 
; 
; void setupLTC1298 (int cs, int clk, int data)
; {
L2:
	.dbline 20
; 
; //Set Clk to output
; SET(DIRA, clk);
	.dbline 20
	mov R15,#1	
	shl R15,R1	
	or 0x1f6,R15	
	.dbline 20
L3:
	.dbline 20
L5:
	.dbline 22
; //set cs to output
; SET(DIRA, cs);
	.dbline 22
	mov R15,#1	
	shl R15,R0	
	or 0x1f6,R15	
	.dbline 22
L6:
	.dbline 22
L8:
	.dbline 24
; //Set to idel high
; SET(OUTA, cs);
	.dbline 24
	mov R15,#1	
	shl R15,R0	
	or 0x1f4,R15	
	.dbline 24
L9:
	.dbline 24
	.dbline 27
; 
; //Save cs, clk, data for later use
; LTC1298_cs = cs;
	@FSTOREL	
	.long _LTC1298_cs	
	.long R0	
	.dbline 28
; LTC1298_clk = clk;
	@FSTOREL	
	.long _LTC1298_clk	
	.long R1	
	.dbline 29
; LTC1298_data = data;
	@FSTOREL	
	.long _LTC1298_data	
	.long R2	
	.dbline -2
L1:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r data 2 I
	.dbsym r clk 1 I
	.dbsym r cs 0 I
	.dbend
	.dbfunc e ltc1298GetAdcVal _ltc1298GetAdcVal fI
;        channel -> R4
_ltc1298GetAdcVal::
	@FENTER	
	.long R4,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 37
; 
; 
; 
; 
; }
; 
; int ltc1298GetAdcVal(int channel)
; {
	.dbline 39
;  
;  if (channel == 0) // if Channel 0 is selected 
	cmp R4,#0	WZ
IF_NE	add PC,#24	;Jump to L12
	.dbline 40
;  {
	.dbline 41
;  ltc1298ShiftOut(LTC1298_CH0);  // Send ch0 command
	@FLOADL	
	.long _LTC1298_CH0	
	.long R0	
	@FCALL	
	.long _ltc1298ShiftOut	
	.dbline 42
;  }
	add PC,#20	;Jump to L13
L12:
	.dbline 44
;  else
;  {
	.dbline 45
;  ltc1298ShiftOut(LTC1298_CH1);  // Else ch1 was called and send ch 1 command
	@FLOADL	
	.long _LTC1298_CH1	
	.long R0	
	@FCALL	
	.long _ltc1298ShiftOut	
	.dbline 46
;  }
L13:
	.dbline 48
;  
;  return ltc1298ShiftIn(); // get the data and return it.
	@FCALL	
	.long _ltc1298ShiftIn	
	mov R15,R0	
	.dbline -2
L11:
	@FPOP	
	.long R15,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r channel 4 I
	.dbend
	.dbfunc s ltc1298ShiftOut _ltc1298ShiftOut fV
;        counter -> R4
;            val -> R0
_ltc1298ShiftOut:
	@FENTER	
	.long R4,R14,R15,0	
	.dbline -1
	.dbline 53
;  
; }
; 
; static void ltc1298ShiftOut(int val)
; {
L15:
	.dbline 58
; 
; int counter;
; 
; // Make sure data is an output
; SET(DIRA, LTC1298_data);
	.dbline 58
	@FLOADL	
	.long _LTC1298_data	
	.long R15	
	mov R14,#1	
	shl R14,R15	
	or 0x1f6,R14	
	.dbline 58
L16:
	.dbline 58
L18:
	.dbline 61
; 
; // Take CS low
; CLR(OUTA, LTC1298_cs);
	.dbline 61
	@FLOADL	
	.long _LTC1298_cs	
	.long R15	
	mov R14,#1	
	shl R14,R15	
	neg R15,R14	
	sub R15,#1	
	and 0x1f4,R15	
	.dbline 61
L19:
	.dbline 61
	.dbline 63
; 
; for(counter = 0; counter < 4; counter++)
	mov R4,#0	
L21:
	.dbline 64
; {
L25:
	.dbline 66
; // Make the clk low
; CLR(OUTA, LTC1298_clk);	
	.dbline 66
	@FLOADL	
	.long _LTC1298_clk	
	.long R15	
	mov R14,#1	
	shl R14,R15	
	neg R15,R14	
	sub R15,#1	
	and 0x1f4,R15	
	.dbline 66
L26:
	.dbline 66
	.dbline 70
; 	
; 
; // set the bit
;  if ((val  & 0b1000) == 0b1000)// if the value to be shifted is a 1
	mov R15,R0	
	and R15,#8	
	cmp R15,#8	WZ
IF_NE	add PC,#28	;Jump to L28
	.dbline 71
;  	{
L30:
	.dbline 72
; 	SET(OUTA, LTC1298_data);
	.dbline 72
	@FLOADL	
	.long _LTC1298_data	
	.long R15	
	mov R14,#1	
	shl R14,R15	
	or 0x1f4,R14	
	.dbline 72
	.dbline 72
	.dbline 73
; 	}
	add PC,#32	;Jump to L29
L28:
	.dbline 75
;  else // the value is a 0
; 	{
L33:
	.dbline 76
; 	CLR(OUTA, LTC1298_data);
	.dbline 76
	@FLOADL	
	.long _LTC1298_data	
	.long R15	
	mov R14,#1	
	shl R14,R15	
	neg R15,R14	
	sub R15,#1	
	and 0x1f4,R15	
	.dbline 76
L34:
	.dbline 76
	.dbline 77
; 	}
L29:
L36:
	.dbline 80
; 
; // Make clock high
; SET(OUTA, LTC1298_clk);
	.dbline 80
	@FLOADL	
	.long _LTC1298_clk	
	.long R15	
	mov R14,#1	
	shl R14,R15	
	or 0x1f4,R14	
	.dbline 80
L37:
	.dbline 80
	.dbline 83
; 	
; 	//move val left 1 spot
; 	val = val << 1;	
	shl R0,#1	
	.dbline 85
; 
; }
L22:
	.dbline 63
	add R4,#1	
	.dbline 63
	cmps R4,#4	WC
IF_B	sub PC,#148	;Jump to L21
L39:
	.dbline 88
; 
; // release data line while 4th input pin is high
; CLR(DIRA, LTC1298_data);
	.dbline 88
	@FLOADL	
	.long _LTC1298_data	
	.long R15	
	mov R14,#1	
	shl R14,R15	
	neg R15,R14	
	sub R15,#1	
	and 0x1f6,R15	
	.dbline 88
L40:
	.dbline 88
L42:
	.dbline 91
; 
; // Make clock low 
; CLR(OUTA, LTC1298_clk);
	.dbline 91
	@FLOADL	
	.long _LTC1298_clk	
	.long R15	
	mov R14,#1	
	shl R14,R15	
	neg R15,R14	
	sub R15,#1	
	and 0x1f4,R15	
	.dbline 91
L43:
	.dbline 91
	.dbline -2
L14:
	@FPOP	
	.long R15,R14,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r counter 4 I
	.dbsym r val 0 I
	.dbend
	.dbfunc s ltc1298ShiftIn _ltc1298ShiftIn fI
;        counter -> R2
;         result -> R1
_ltc1298ShiftIn:
	@FENTER	
	.long R14,R15,0	
	.dbline -1
	.dbline 96
; 
; }
; 
; static int ltc1298ShiftIn(void)
; {
	.dbline 98
; 
; int counter, result=0;
	mov R1,#0	
L46:
	.dbline 100
; // Make sure clock is low to start
; CLR(OUTA, LTC1298_clk);
	.dbline 100
	@FLOADL	
	.long _LTC1298_clk	
	.long R15	
	mov R14,#1	
	shl R14,R15	
	neg R15,R14	
	sub R15,#1	
	and 0x1f4,R15	
	.dbline 100
L47:
	.dbline 100
	.dbline 103
; 
; // its to 13 because 1st bit is a null bit
; for(counter = 0; counter < 13; counter++)
	mov R2,#0	
L49:
	.dbline 104
; 	{
L53:
	.dbline 106
; 	
; 	SET(OUTA, LTC1298_clk); // set clock high
	.dbline 106
	@FLOADL	
	.long _LTC1298_clk	
	.long R15	
	mov R14,#1	
	shl R14,R15	
	or 0x1f4,R14	
	.dbline 106
L54:
	.dbline 106
	.dbline 109
; 	
; 	
; 	if (pinState(LTC1298_data) == 1) // return is a 1
	@FLOADL	
	.long _LTC1298_data	
	.long R15	
	mov R14,0x1f2
	shr R14,R15	
	mov R15,R14	
	and R15,#1	
	cmp R15,#1	WZ
IF_NE	add PC,#20	;Jump to L56
	.dbline 110
; 	  {
	.dbline 111
; 	    result = (result << 1) + 1;
	mov R15,R1	
	shl R15,#1	
	mov R1,R15	
	add R1,#1	
	.dbline 113
; 		//printf("Bit %d High %c", counter,13);
; 	  }
	add PC,#4	;Jump to L57
L56:
	.dbline 115
; 	else // return is a 0
; 	  {
	.dbline 116
; 	   result = result << 1;
	shl R1,#1	
	.dbline 119
; 	   
; 		//printf("Bit %d Low %c", counter,13);
; 	  }
L57:
L58:
	.dbline 121
; 	 
; 	 CLR(OUTA, LTC1298_clk); // Set clock low, data is valid on traling edge 
	.dbline 121
	@FLOADL	
	.long _LTC1298_clk	
	.long R15	
	mov R14,#1	
	shl R14,R15	
	neg R15,R14	
	sub R15,#1	
	and 0x1f4,R15	
	.dbline 121
L59:
	.dbline 121
	.dbline 122
;    }
L50:
	.dbline 103
	add R2,#1	
	.dbline 103
	cmps R2,#13	WC
IF_B	sub PC,#128	;Jump to L49
L61:
	.dbline 123
; SET(OUTA, LTC1298_cs); 
	.dbline 123
	@FLOADL	
	.long _LTC1298_cs	
	.long R15	
	mov R14,#1	
	shl R14,R15	
	or 0x1f4,R14	
	.dbline 123
L62:
	.dbline 123
	.dbline 125
; 
; return result;
	mov R0,R1	
	.dbline -2
L45:
	@FPOP	
	.long R15,R14,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r counter 2 I
	.dbsym r result 1 I
	.dbend
	.area bss(ram,rel)
	.dbfile C:\PROGRA~1\iccv7prop\Projects\LTC1298\Ltc1298.c
	.align	4
_LTC1298_data:
	.blkb 4
	.dbsym s LTC1298_data _LTC1298_data I
	.align	4
_LTC1298_clk:
	.blkb 4
	.dbsym s LTC1298_clk _LTC1298_clk I
	.align	4
_LTC1298_cs:
	.blkb 4
	.dbsym s LTC1298_cs _LTC1298_cs I
